<template>
  <v-menu
    ref="menu2"
    v-model="menu2"
    :close-on-content-click="false"
    :return-value.sync="months"
    transition="scale-transition"
    offset-y
    max-width="290px"
    min-width="auto"
  >
    <template v-slot:activator="{ on, attrs }">
      <v-text-field
        v-model="monthsRangeText"
        label="เดือนที่เริ่ม ~ เดือนที่จบ"
        prepend-inner-icon="mdi-calendar"
        readonly
        outlined
        rounded
        v-bind="attrs"
        v-on="on"
      ></v-text-field>
    </template>
    <v-date-picker
      v-model="months"
      ref="picker2"
      @input="selectMonth"
      type="month"
      reactive
      show-current=""
      no-title
      range
    >
      <v-spacer></v-spacer>
      <v-btn text color="primary" @click="saveMonth(months)">
        OK
      </v-btn>
      <v-btn text color="primary" @click="menu2 = false">
        Cancel
      </v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      months: [],
      monthShow: [],
      menu2: false,
    };
  },
  created() {
    this.defaultMonth();
    this.$emit("update:inputMonth", this.months);
  },
  computed: {
    monthsRangeText() {
      let start = moment(this.months[0])
        .locale("th")
        .format("LL");
      let end = moment(this.months[1])
        .locale("th")
        .format("LL");
      this.monthShow[0] = `${start.split(" ")[1]} ${start.split(" ")[2]}`;
      this.monthShow[1] = `${end.split(" ")[1]} ${end.split(" ")[2]}`;
      return this.monthShow.join(" ~ ");
    },
  },
  methods: {
    daysInMonth(month, year) {
      return new Date(year, month, 0).getDate();
    },
    saveMonth(date) {
      this.$refs.menu2.save(date);
      this.$emit("update:inputMonth", date);
    },
    selectMonth() {
      let dateToString = `${this.months[0]}`;
      let month = dateToString.split("-");
      let calMonth = parseInt(month[1]) + 6;
      if (calMonth > 12) {
        let yearNew = parseInt(month[0]) + 1;
        let cal = 12 - calMonth;
        let result = Math.abs(cal);

        let newMonth = `${yearNew}-${result > 9 ? `${result}` : `0${result}`}`;
        this.months.push(newMonth);
      } else {
        let newMonth = `${month[0]}-${
          calMonth > 9 ? `${calMonth}` : `0${calMonth}`
        }`;
        this.months.push(newMonth);
      }
    },
    defaultMonth() {
      let currentDate = moment(this.$options.filters.dateNow())
        .add(543, "year")
        .format("YYYY-MM");
      this.months[1] = currentDate;
      let month = currentDate.split("-");
      let calMonth = parseInt(month[1]) - 6;

      if (calMonth <= 0) {
        let yearNew = parseInt(month[0]) - 1;
        let unNegative = Math.abs(calMonth);
        let calMonthNew = 12 - unNegative;
        let newMonth = moment(`${yearNew}-${calMonthNew}`).format("YYYY-MM");
        this.months[0] = newMonth;
      } else {
        let newMonth = moment(`${month[0]}-${calMonth}`).format("YYYY-MM");
        this.months[0] = newMonth;
      }
    },
  },
};
</script>

<style></style>
